#include<stdio.h>
#include<string.h>
#include "tfb2any.h"
#include "y.tab.h"
void range_to_list(Symbol *);  /* x=1..2 ->  [x,1,2],Maple$B$X$O$=$N$^$^(B */
void change_mod(Symbol *);     /* 5%2 -> $B3F!9$N%=%U%H$N7A<0$KJQ49(B */
void rangestchange(Symbol *);  /* step$BIU$-(BRANGE$B$NE,@Z$JJQ7A(B */
int check_matrix(Symbol *); /*2$B=E%j%9%H$,(Bmatrix$B$rI=$9$+$I$&$+$N%A%'%C%/(B*/
void makematrix(Symbol *); /*$B9TNs$r:n$k(B(type$B$r(BROW$B$K=q$-49$($k$@$1(B)*/

/* $BHO0O%j%9%H$rIU$12C$($k$?$a$N4X?t72(B(asir,mathematica,maple$B$X$NJQ49(B)  */
void append_check(Symbol *); /*$BI,MW$+%A%'%C%/(B.$BI,MW$J$iHO0O%j%9%HIU$12C$($k(B*/
void huteigen_search(Symbol *,char *);
/*$B;XDjITDj85$,0z?tFb$KB8:_$9$k$+8!:w(B:$B8+$D$+$C$?$i(Bfound$B$K(B1$B$rBeF~(B*/
int check_list_arg(Symbol *,char *);/*$B;XDjITDj85HO0O%j%9%H$,4{$K$"$k$+(B*/

/*
  $BHO0O%j%9%H$rFHN)(B(matlab$B$X$NJQ49(B)
  $BNc(B:
  asir@plot(x,[x,0,100]);
  -->
  x=0:100
  plot(x)
 */
void rangelist_split(Symbol *);
void list_to_range(Symbol *);

/* $BMWAGHV9f$r$:$i$9$?$a$N4X?t72(B */
void index_dec(Symbol *);  /* $BMWAGHV9f$N$&$A(BNUMBER$B$r#1$DA}$d$9(B */
void dec(Symbol *);      /* $B>e$+$i8F$P$l$k4X?t(B */
int iwa_atoi(char *);   /* $BJ8;zNs(B->$B@0?t(B */
void iwa_itoa(int,char *);     /* $B@0?t(B->$BJ8;zNs(B */
void reverse(char *);   /* $BJ8;zNs$r5U$K$9$k(B*/

/*
  transform:
  $B3F%N!<%I$NJQ49(B 
  target$B$O$I$N%=%U%H$KJQ49$7$?$$$+!"$H$$$&Dj?t(B.
  *.y$B%U%!%$%k$NCf$GDj5A$5$l$F$$$k30ItJQ?t(B 
*/ 

extern int matrix_flag; /* $B9TNs:n@.%U%i%0(B */

/* $B#1HV30B&$N4X?t$G$"$k$3$H$r<($9(B(range$B%j%9%HIU2CMQ(B) */
static int function_depth=0;  /* $B4X?t$N?<$5$r<($9(B(0:$B:G$b30B&$N4X?t(B) */

void transform(Symbol *sp)
{
  int i;
  if(sp->number==0){  /* $B;R6!$,#0(B */
	if(sp->mode!=NONE && sp->type==FUNCTION && target!=PMATHML && target!=OPENMATH){
	  functionchange(sp);  /* presentation mathml $B$OJQ49BP>]30(B */
	}
	if(sp->mode!=NONE && sp->type==CONST && target!=PMATHML && target!=OPENMATH){
	  constchange(sp);    /* presentation mathml $B$OJQ49BP>]30(B */
	}
  }
  else{
	/********* $BA0Av::JQ49(B *******************/
	if(sp->mode!=NONE && sp->type==FUNCTION && target!=PMATHML && target!=OPENMATH){
	  functionchange(sp);
	}

	if(sp->type==RANGEST){
	  rangestchange(sp); /*RANGEST(step$BIU$-(BRANGE)$B$NJQ49(B*/
	}

	if(sp->type==LIST) /*2$B=E%j%9%H$G$5$i$KMWAG?t$,F1$8%j%9%H$r;}$D(B->matrix */
	  if(matrix_flag==1)
		if(check_matrix(sp)==1)
		  makematrix(sp);

	if(sp->type==OPE)
	  if(strcmp(sp->value,"%")==0)
		change_mod(sp);       /* $B3F!9$N(Bmod$BI=8=$X(B */

	if(sp->type==ELEMENT && target==ASIR)/*tfb2asir:$BMWAGHV9f#18:$i$9(B*/
	  index_dec(sp);     /* $B$d$C$F$$$k$3$H$O(BNUMBER$B$N;~$N<B:]$N(B-1$B7W;;(B */

	if(sp->type==FUNCTION)  /* $B4X?t$N?<$5$r%+%&%s%H(B*/
	  function_depth++;    /* $BF~$l;R$N4X?t8F$S=P$7$N2s?t(B($B?<$5(B)$B$r%+%&%s%H(B */
	/********* $BA0Av::JQ49$3$3$^$G(B ***************/

	/**************  $BCfAv::JQ49(B            **********/
	for(i=0;i<sp->number;i++){
	  transform(*((sp->childp)+i));   /* $B;R6!$KBP$7$F$bJQ49$r(B */
	}
	/************** $BCfAv::JQ49$3$3$^$G(B  ************/

	/**************** $B8eAv::JQ49(B ****************/
	range_to_list(sp);    /* RANGE$B$J$i%j%9%H$KJQ49(B($BAv::8eJQ49(B) */

	if(sp->type==FUNCTION)  /* $B4X?t$N?<$5$N%+%&%s%H(B */
	  function_depth--;
	
	if(sp->type==FUNCTION && (target==ASIR || target==MATH || target==MAPLE) && function_depth==0){  /* function_depth$B$,(B0:$B:G$b30B&$N4X?t(B */
	  /* printf("test"); for debug */
	  append_check(sp); /*$BJ]B8$7$F$"$C$?HO0O%j%9%H$r(B($BI,MW$J$i(B)$BIU$12C$($k(B*/
	}

	if(sp->type==FUNCTION && target==MATLAB)
	  rangelist_split(sp);

	/*************** $B8eAv::JQ49$3$3$^$G(B *******************/
  }
}


void functionchange(Symbol *sp)   /* $B4X?tL>$NJQ49(B */
{
  char *str;   /* $BJQ497k2L$K$7$?$$$b$N$rBeF~(B */
  char *tmp;   /* realloc$B$N@.8y$+<:GT$+$NH=CGMQ(B */
  str=function_searchtable(sp); /*str$B$K$OJQ498e$N4X?tL>$,JV$5$l$k(B*/
  if(strlen(sp->value) < strlen(str)){/*$B$b$7$b:#$h$jD9$$4X?tL>(B */
	tmp=(char *)realloc(sp->value,strlen(str)+1); /* +1 for '\0' */
	if(tmp==NULL)                    /* $B$KCV49$5$l$k$J$i%a%b%j:F3NJ](B */
	  execerror("realloc , out of memory",(char *)0);
	sp->value=tmp;    /* realloc$B@.8y(B */
  }
  strcpy(sp->value,str);
}


void constchange(Symbol *sp)   /*$BDj?t$NJQ49(B($B>e$N4X?t$H$[$\F1$8(B) */
{
  char *str;
  char *tmp;
  str=const_searchtable(sp);  
  if(strlen(sp->value) < strlen(str)){
	tmp=(char *)realloc(sp->value,strlen(str)+1); 
	if(tmp==NULL)                    
	  execerror("realloc , out of memory",(char *)0);
	sp->value=tmp;    
  }
  strcpy(sp->value,str);  
}


int check_matrix(Symbol *sp)
{
  int i;
  int j;
  if(sp->number==0 || sp->number==1) /*$B6u%j%9%H$d%a%s%P$,#1$D$N;~(B->matrix$B0c$&(B*/
	return 0;
  if(sp->childp[0]->type!=LIST)   /*for$BJ8$NET9g>e(B1$B$D$a$N;R$OJL$K%A%'%C%/(B*/
	return 0;
  j=(sp->childp[0])->number;
  for(i=1 ; i<sp->number ; i++){
	if(sp->childp[i]->type!=LIST)
	  return 0;   /*$B%a%s%P$,(BLIST$B$G$J$$(B->matrix$B$G$J$$(B*/
	if(sp->childp[i]->number!=j)
	  return 0;   /*$B%a%s%P$NCf$KMWAG?t$N0c$&(BLIST$B$,$$$k(B*/
	j=sp->childp[i]->number; /*$BJ]B8(B*/
  }
  return 1;  /* $B$9$Y$F$N>r7o$r%/%j%"$7$?$b$N$,(Bmatrix */
}


void makematrix(Symbol *sp)
{
  int i;
  sp->type=MATRIX;
  for(i=0;i<sp->number;i++)   /* $B=q$-49$((B */
	sp->childp[i]->type=ROW;
}

/*
  Maple$B$KJQ49$9$k$H$-0J30$O(B
  x=1..2 -> x,1,2$B$N%j%9%H$X(B
  Maple$B$XJQ49$9$k$H$-$O(BASSIGN->EQ$B$r$9$k(B.$B$3$&$7$F$*$+$J$$$H(Bx:=1..2$B$H$J$C$F$7$^$&(B
  $B4X?t8F$S=P$7$rB?$/$9$k$h$j(Btransform$B$NCf$G>r7o%A%'%C%/$7$?$[$&$,(B
  $BNI$$5$$b$9$k(B->$B%3!<%I$N8+$d$9$5$@$1$r8+$?(B
*/
void range_to_list(Symbol *sp)  
{
  if(sp->type==ASSIGN && ((sp->childp[0])->type==HUTEIGEN ||(sp->childp[0])->type==VAR) && ((sp->childp[1])->type==RANGE || (sp->childp[1])->type==RANGEST)){
	if(target!=MAPLE && target!=MATLAB){ /*MAPLE$B$KJQ49$9$k$H$-$O(BRANGE$B$N$^$^(B*/ 
	  sp->type=LIST;
	  delete_up(sp,1);  /* 1$BHVL\$N;R$r$D$V$7$F(Bup */
	}
	else if(target==MAPLE){/*Maple:ASSIGN->EQ$B$r$9$k(B($B$3$N$^$^$@$HBeF~5-9f(B:=)*/
	  sp->type=EQ;
	} 
  }
}


/* 
   mod$B$NJQ494X?t(B change_mod(Symbol *)
                 |-->  5%2(asir)
   5%2(tfb)  ----|-->  Mod[5,2](mathematica) 
                 |-->  5 mod 2(maple)
                 |-->  rem(5,2) (matlab)
*/ 

void change_mod(Symbol *sp)
{
  char *tmp;
  if(target==ASIR)
	return ;  /* $B2?$b$7$J$$(B */
  if(target==MATH){
	sp->type=FUNCTION;
	tmp=(char *)realloc(sp->value,4);  /* Mod(\0)$B$N$?$a$N#4J8;z3NJ](B */
	if(tmp==NULL)
	  execerror("realloc,out of memory",(char *)0);
	sp->value=tmp; /* $B3NJ]@.8y(B */
	strcpy(sp->value,"Mod");
  }    
  if(target==MAPLE){   /* type$B$O(BOPE$B$N$^$^$G(BOK */
	tmp=(char *)realloc(sp->value,4); /*mod(\0)$B$N$?$a(B6$BJ8;z3NJ](B($BN>%5%$%I6uGr(B)*/
	if(tmp==NULL)
	  execerror("realloc,out of memory",(char *)0);
	sp->value=tmp; /* $B3NJ]@.8y(B */
	strcpy(sp->value," mod ");
  }
  if(target==MATLAB){
	sp->type=FUNCTION;
	tmp=(char *)realloc(sp->value,4);  /* rem(\0)$B$N$?$a$N#4J8;z3NJ](B */
	if(tmp==NULL)
	  execerror("realloc,out of memory",(char *)0);
	sp->value=tmp; /* $B3NJ]@.8y(B */
	strcpy(sp->value,"rem");	
  }
}



/*
  $BMWAGHV9f$N$&$A$N(BNUMBER$B$r#1$:$i$9$?$a$N4X?t72(B
  $B$?$@$7(BNUMBER$B0J30$N=hM}$O(Bcheck_type$B$KG$$;$k(B
  (check_type$B$O(BNUMBER$B0J30$K(B"-1"$B$H$$$&J8;zNs$rIU$12C$($k$@$1(B)
*/
void index_dec(Symbol *sp)  /* $BMWAGHV9f$r#1A}$d$9(B */
{
  int i;
  for(i=0;i<sp->number;i++)
	dec(sp->childp[i]);
}


void dec(Symbol *sp)  /* $B8:$i$9(B */
{
  int i;
  char value[100];  /* $B7k2L$O(B100$B7e$^$G(BOK */
  char *tmp;
  if(sp->type==NUMBER){
	i=iwa_atoi(sp->value);
	i--;   /* $B#1$D$U$d$7$F(B */
	iwa_itoa(i,value);  /*$B7k2L$rJ8;zNs$X(B*/
	if(strlen(sp->value)<strlen(value)){
	  tmp=(char *)realloc(sp->value,strlen(value)+1); /* +1 for '\0' */
	  if(tmp==NULL)
		execerror("realloc,out of memory",(char *)0);
	  sp->value=tmp;  /* realloc$B@.8y(B */
	}
	strcpy(sp->value,value);
  }
}


int iwa_atoi(char *a)
{
  int i;
  int value;
  for(value=0,i=0;a[i]!='\0';i++){
	if(isdigit(a[i]))
	  value=10*value+(a[i]-'0');
	if(a[i]=='.')
	  execerror("index must be a integer",(char *)0);
  }
  return value;
}


void iwa_itoa(int n,char *value)
{
  int i=0;
  do{
	value[i++]=n%10+'0';   /* $B2<$N7e$+$i#1$D$:$DF~$l$F9T$/(B */
	n=n/10;
  }while(n);
  value[i]='\0';
  reverse(value);
}


void reverse(char *s)  /* $BJ8;zNs$r5U=g$K(B */
{
  int c;
  int i;
  int j;
  for(i=0,j=strlen(s)-1;i<j;i++,j--){ /* -1 for '\0' */
	c=s[i];
	s[i]=s[j];
	s[j]=c;
  }
}
/* -----------$BE:;zJQ494X?t72$O$3$3$^$G(B-------------  */


void rangestchange(Symbol *sp)
{
  if(target==ASIR || target==MATH || target==MAPLE){
	delete(sp,2);   /*3$BHVL\$N;R(B(step)$B$r:o=|(B*/
  }
  else if(target==MATLAB){
	swap(sp,1,2); /*1$BHVL\$H(B2$BHVL\$r8r49(B 1..2:0.5->1:0.5:2$B$H$7$?$$0Y(B*/
  }
} 


/*
  $B0J2<(B3$B$D$O(B
  $B0z?t$X$NHO0O%j%9%HDI2C$N$?$a$N4X?t(B
  append_check
  huteigen_search
  check_list_arg
*/


/*
  append_check:$BDI2C$9$Y$-$+%A%'%C%/(B.
  $BI,MW$J$iDI2C$9$k(B.

  $BDI2C>r7o(B:
  $B4X?t$N0z?t$NCf$K(Brange$B%j%9%H$KEPO?$5$l$F$$$k(BHUTEIGEN$B$,;H$o$l$F$$$F(B,
  $B$J$*$+$D(B,$B$=$NITDj85$NHO0O$rI=$9%j%9%H$,0z?t$NCf$K$J$$$3$H(B.
*/
static int found=0;  /* $B8+$D$+$C$?$+$I$&$+(B. 1:$BH/8+(B 0:$BL$H/8+(B*/

void append_check(Symbol *sp) 
{
  int i;
  Symbol *list;  /* $BA^F~$7$?$$(Blist$B$rJ]B8(B*/
  char *str;     /* $B8!:wHO0OITDj85L>$rJ]B8(B */
  for(i=1;i <= rangelist_number();i++){   /* range$B%j%9%H$N?t0J2<$N4V(B */
	str=rangevar_pickup(i);  /* i$BHVL\$NEPO?L>$N<h$j=P$7(B*/
	huteigen_search(sp,str); /*range$BITDj85$N8!:w(B*/
	if(found==1){
	  if(check_list_arg(sp,str)==0){/*$B4{$K0z?t$K$=$NITDj85HO0O%j%9%H$O$"$k$+(B*/
		list=lookup_rangevar(str);  /* $BA^F~$9$k%j%9%H$X$N%]%$%s%?(B*/
		insert(sp,list);    /*$BHO0O%j%9%H$rDI2C(B*/
	  }
	}
	found=0;   /* found$B$r(B0$B$KLa$9(B */
  }
}


/* 
   huteigen_search
   $BITDj85%j%9%H$KEPO?$5$l$F$$$kITDj85$,0z?t$NCf$G;H$o$l$F$$$k$+%A%'%C%/(B
*/
void huteigen_search(Symbol *sp,char *str)
{
  int i;
  if(sp->number==0){
	if(sp->type==HUTEIGEN || sp->type==VAR)
	  if(strcmp(sp->value,str)==0)   /*$BH/8+(B*/
		found=1; /* $BH/8+7k2L$rBeF~(B */
	return;
  }
  else{
	for(i=0;i<sp->number;i++){
	  huteigen_search(*((sp->childp)+i),str);   /* $B;R6!$KBP$7$F$bA\:w$r(B */
	}
  }
}


/*
  check_list_arg
  $B;XDj$5$l$?ITDj85$NHO0O%j%9%H$,4{$KB8:_$9$k$+%A%'%C%/(B

  $BHO0O%j%9%H$NH=Dj>r7o(B:
  $B85$N?t$,#3$N%j%9%H$G#1$D$a$,ITDj85$G$"$k(B(Asir,Mathematica)

  $BITDj85(B=range $B$N<0$,$"$k(B(Maple)

  $B$"$k(B:1
  $B$J$$(B:0
*/
int check_list_arg(Symbol *sp,char *huteigen)
{
  int i;
  Symbol *tmp;
  for(i=0;i<sp->number;i++){
	tmp=sp->childp[i];   /* $BJ]B8(B */
	if(target==MATH || target==ASIR)
	  if(tmp->type==LIST && tmp->number==3 && tmp->childp[0]->type==HUTEIGEN)
		if(strcmp(tmp->childp[0]->value,huteigen)==0)
		  return 1;   
	if(target==MAPLE)   /*maple x=1..2$B$N$h$&$J0z?t$rC5$9(B  */
	  if(tmp->type==EQ && tmp->childp[0]->type==HUTEIGEN && (tmp->childp[1]->type==RANGE || tmp->childp[1]->type==RANGEST))
		if(strcmp(tmp->childp[0]->value,huteigen)==0)
		  return 1;
  }
  return 0;
}



/* 
   $BHO0O%j%9%H(B($BMWAG?t$,(B3$B$G(B1$B$D$a$,ITDj85$N%j%9%H(B)$B$rA\:w$7(B,
   $B$b$7$"$l$PFHN)$7$FI=<($5$;(B,$B#2$D$NJ8$K$o$1$k(B
   rangelist_split
*/

void rangelist_split(Symbol *sp)
{
  int i;
  Symbol *tmp;
  for(i=0;i<sp->number;i++){
	tmp=sp->childp[i];   /* $BJ]B8(B */
	if((tmp->type==LIST && tmp->number==3 && tmp->childp[0]->type==HUTEIGEN)
	   || (tmp->type==ASSIGN && tmp->childp[0]->type==HUTEIGEN && tmp->childp[1]->type==RANGE)){
	  if(tmp->type==LIST)
		list_to_range(tmp); /* $BHO0O%j%9%H(B(maple$B$G$O(Brange$BBeF~(B)->range$BBeF~J8$X(B */
	  treeprint(tmp);  /* $B$*@h$K0u;z(B */
	  printf("\n");    /* treeprint$B$@$1$J$N$G=*$o$j$K2~9TIU$+$J$$(B*/
	  delete(sp,i);  /* $B:o=|(B */
	  i--; /* $B;R$,#1$D8:$C$?J,%+%&%s%H$b$:$i$9(B */
	}
  }
}


/* 
   $BHO0O%j%9%H$N(Brange$B$X$NJQ49(B
*/
void list_to_range(Symbol *sp)
{
  if(target!=MAPLE){   /* maple(x=0..1$B$N$h$&$J<0(B)$B$OL5;k(B */
	Symbol *range=makesymbol(RANGE,NONE,NULL);
	sp->type=ASSIGN;
	insert_follow_down(sp,range,1);
  }
}


/****
$B9=J8LZ$NA^F~(B,$B:o=|4X?t72!';H$&$3$H$K$J$k$+$OL$Dj(B
i$BHVL\$H$$$&$N$OG[Ns$HF1$8$/(B0$BHV$+$i?t$(;O$a$?%+%&%s%H(B

void insert(Symbol *parent,Symbol *child)
parent$B$N:G8e$N;R6!$K(Bchild$B$rDI2C(B

void insert_into(Symbol *parent,Symbol *child,int i)
parent$B$N(Bi$BHVL\$N;R6!$K(Bchild$B$rDI2C(B(i$BHV$N%9%Z!<%9$r$+$-J,$1$FA^F~(B)

void insert_down(Symbol *parent,,Symbol *child,int i)
parent$B$N(Bi$BHV$N%9%Z!<%9$r>h$C<h$j(B,$BA^F~8e(Bi$BHV$N;R$r=>$($k(B

void insert_follow_down(Symbol *,Symbol *,int)
parent$B$N(Bi$BHV$N%9%Z!<%9$r>h$C<h$j(B,$BA^F~8e(Bi$BHV0J9_$N;R$r=>$($k(B($B85$N%N!<%I$+$i$O<h$j=|$/(B)

void delete_up(Symbol *parent,int i)
parent$B$+$i(Bi$BHVL\$N;R6!$r:o=|$7$F(B
$B:o=|$7$?%N!<%I$N;R$r?F$K<u$1EO$9(B

void delete(Symbol*parent,int i)
i$BHVL\$N%N!<%I$r:o=|(B(+$B$A$g$C$H$7$?@0M}(B)$B$9$k(B

void delete_recursive(Symbol *sp)
$B>e$+$i8F$S=P$5$l$k4X?t(B
sp$B%N!<%I$r$=$N;RB9$4$H:o=|(B($B:F5"E*$K(B)

delete_up$B$H(Binsert_follow_down$B$O:#$N=jF0:n3NG'$G(BOK
****/

void insert(Symbol *parent,Symbol *child) /* $B;R6!$NA^F~(B($B#1HV:G8e(B) */
{
  Symbol **tmp;
  parent->number++;   /*$B;R$N?t$r0l$DA}$d$9(B  */
  if(parent->number>CHILD){   /* $B%G%U%)%k%H$N;R6!$N?tD6$($F$?$i:F3NJ](B */
	tmp=(Symbol **)realloc(parent->childp,(parent->number)*sizeof(Symbol *));
	if(tmp==NULL)
	  execerror("realloc,out of memory",(char *)0);
	parent->childp=tmp;  /* $B@.8y(B  */	
  }	
  (parent->childp)[parent->number-1]=child;  /*$BG[Ns$O#0$+$i;O$^$k(B -> -1*/
}


void insert_into(Symbol *parent,Symbol* child,int i){ /* i$BHVL\$K;R6!$rA^F~(B */
  Symbol **tmp;                          /* $B$b$A$m$sHV9f$O(B0$B$+$i%+%&%s%H(B */
  int index;

  if(i>parent->number) /* 1$BHV8e$m$h$j$b1|$KA^F~$7$h$&$H$7$?$H$-%(%i!<(B*/
	execerror("insert_into,out of range",(char *)0);

  parent->number++;   /*$B;R$N?t$r0l$DA}$d$9(B  */
  if(parent->number>CHILD){   /* $B%G%U%)%k%H$N;R6!$N?tD6$($F$?$i:F3NJ](B */
	tmp=(Symbol **)realloc(parent->childp,(parent->number)*sizeof(Symbol *));
	if(tmp==NULL)
	  execerror("realloc,out of memory",(char *)0);
	parent->childp=tmp;  /* $B@.8y(B  */	
  }   /* -1 $B$OG[Ns$NMWAG$r9MN8(B */

  for(index=(parent->number)-1; index>i ;index--){ /* i$BHV$N%9%Z!<%93+$1$k(B */
	parent->childp[index]=parent->childp[index-1];
  }
  parent->childp[i]=child;   /* i$BHVL\$KA^F~(B */
}


void insert_down(Symbol *parent,Symbol *child,int i)
{
  child->childp[0]=parent->childp[i]; /* i$BHV$NMWAG$r;R$K=>$($k(B */
  child->number=1;    /*$B;R$N?t$O(B1*/
  parent->childp[i]=child; /* $B>h$C<h$j(B */
}


void insert_follow_down(Symbol *parent,Symbol *child,int i)
{
  int j;
  int k=parent->number;   /* $BJ]B8(B */
  for(j=0;j<parent->number-i;j++)   /* i$BHV0J9_$N;R$r=>$($k(B */
	child->childp[j]=parent->childp[i+j];
  for(j=i;j<parent->number;j++)   /* $B?F$+$i$O=|5n(B */
	parent->childp[j]=NULL;
  parent->number=parent->number-i;   /* $B;R$N?t$b2~$a(B.i$BHV$O;H$&$N$G(B-i$B$G(BOK */
  parent->childp[i]=child; /* $B>h$C<h$j(B */
  child->number=k-parent->number+1;   /* realloc$B$O!#!#4*J[(B */
}


void delete_up(Symbol *parent,int i)/* i$BHVL\$N;R$r:o=|$7$F2<$N;RC#$r2!$7>e$2(B*/
{                                 /* $B$FLZ$r:F9=C[(B */
  int k;
  int j;
  Symbol **tmp; /* realloc$BMQ(B */
  Symbol *deletenode=(parent->childp)[i];   /* i$BHVL\$N;R$X$N%"%I%l%9$rJ]B8(B */
  int number_sum=parent->number+deletenode->number-1;/*$B;R$N?t$NOB(B(-1$B$O:o=|J,(B)*/
  
  if(i>parent->number-1)   /* $B;XDjHV9f$,$*$+$7$$(B */
	execerror("delete_up out of range",(char *)0);
  
  if(number_sum> CHILD){  /* $BM=4|$5$l$k;R$N?t$,B?$$;~(B */
	tmp=(Symbol **)realloc(parent->childp,(number_sum)*sizeof(Symbol *));
	if(tmp==NULL)
	  execerror("realloc,out of memory",(char *)0);
	parent->childp=tmp;  /* $B@.8y(B  */
  }	


  /* 
	 $B:o=|>l=j$rKd$a$k(B($B>e=q$-$9$k(B.$B:8$K5M$a$k(B:free$B$9$k$o$1$G$O$J$$(B)
	 ($B%$%a!<%8(B)$B;R;R>C;R;R(B -> $B;R;R;R;R(BNULL $B5M$a$k(B
  */
  for(j=i;j<parent->number-1;j++){
	parent->childp[j]=parent->childp[j+1]; /* $B>C$9>l=j$+$i:8$K5M$a$F9T$/(B */
  }     /* $BH4$1$?$H$-$N(Bj$B$O(B1$BHV8e$m$N;R(B($B;D$j%+%9(B) */
  parent->childp[j]=NULL;  /* $B$*?,$K$O(BNULL$B$r(B */
  parent->number--;   /* $B:o=|$7$?;R$NJ,8:$i$9(B */
	
  /* $B;R$N<u$1EO$7(B */
  k=parent->number; /* $B%3%T!<@h(Bindex */
  j=0;      /* $B%3%T!<85(Bindex  */
  for( ; j < deletenode->number; k++,j++){
	parent->childp[k]=(deletenode->childp)[j]; /*$B:o=|%N!<%I$N;R$r?F$X<u$1EO$7(B*/
  }
  parent->number=number_sum;  /* $B;R$N?t$r99?7(B */
  free(deletenode->childp);  /* $B:o=|(B */
  free(deletenode);   /* $B:o=|(B */
}


void delete(Symbol *parent,int i) /* i$BHVL\$N%N!<%I$r40A4:o=|$7$F(Bchildp$B$r@0M}(B */
{
  int j;
  delete_recursive(parent->childp[i]);  /* $B;R$r;RB9$^$G4^$a$F40A4:o=|(B  */
  for(j=i;j<parent->number-1;j++){
	parent->childp[j]=parent->childp[j+1]; /* $B>C$9>l=j$+$i:8$K5M$a$F9T$/(B */
  }     /* $BH4$1$?$H$-$N(Bj$B$O(B1$BHV8e$m$N;R(B($B;D$j%+%9(B) */
  parent->childp[j]=NULL;  /* $B$*?,$K$O(BNULL$B$r(B */
  if(parent->number>0)
	parent->number--;   /* $B:o=|$7$?;R$NJ,8:$i$9(B */
}

void delete_recursive(Symbol *sp) /*sp$B%N!<%I$r$=$N;RB9$^$G4^$aA4:o=|(B*/
{                          /* treeprint$B$r;29M$K$7$F$$$k(B */
  int i;
  if(sp->number==0){     /* $B;R6!$,(B1$B?M$b$$$J$$$H$-$O$=$l$r:o=|(B */
	free(sp->childp);   /* $B:o=|(B */
	free(sp);   /* $B:o=|(B */
	return ;
  }
  else{   /* $B;R6!$,$$$k$H$-$K$O;R6!$r:o=|(B($B:F5"!K(B */
	for(i=0;i<sp->number;i++){
	  delete_recursive(*((sp->childp)+i));  /* $B;R6!$KBP$7$FF1$8Av::(B */
	}
	free(sp->childp);    /* $B;R6!$r:o=|$7$?$"$H<+J,$r:o=|(B */
	free(sp);   /* $BK\BN:o=|(B */
  }
}


/* i$BHV$H(Bj$BHV$N;R$rF~$l49$((B*/
void swap(Symbol *sp,int i,int j)
{
  Symbol *tmp=sp->childp[i];
  sp->childp[i]=sp->childp[j];
  sp->childp[j]=tmp;
}

